import { Component } from '@angular/core';

@Component({
    selector: 'my-app',
    template: `<h1 id='mainheader'>My IgniteUI Angular2 App</h1>
    <h2>igValidator</h2>
        <form id="validator1" (ngSubmit)="login()">
            <ig-text-editor [widgetId]="teId" [textMode]="'password'" [placeHolder]="'********'" [width]="'100%'" [(ngModel)]="model.password" name="password" required></ig-text-editor>

            
            <button type="submit">Enter</button>
            <button type="reset">Cancel</button>
        </form>
        <ig-validator [widgetId]='id' [options]='opts'></ig-validator>
    `
})
export class AppComponent {
    private id: string = 'validator1';
    private teId: string = 'editor1';
    private opts: any;
    private teOpts: any = {};
    private model: any = {};
    private validatorRef: any;

   constructor() {
       let self = this;
       this.opts = { onsubmit: true,
        successMessage: "Valid",
        onblur: false,
        create: function(e:any) {
            self.validatorRef = $(e.target).data("igValidator");
        },
        fields: [{
            required: true,
            selector: "#editor1",
            errorMessage: "Error",
            custom: function(value, fieldOptions){
                var myRegEx  = /^(?=.*[0-9])(?=.*[a-z])(?=.*[A-Z])([a-zA-Z0-9]{8,})$/;
                var isValid = myRegEx.test(value);
                return isValid;
            }
        }
       ]};
   }

   login() {
       console.log(this.validatorRef.isValid());
   }
 }
